{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            Copyright (c) 2018 - 2019                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.Graphics;

interface

uses
  {$IFNDEF LCLTMSWEB}
  Vcl.Graphics, Web;
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  Graphics, Web;
  {$ENDIF}

{$IFNDEF LCLTMSWEB}
const
  clScrollBar = Vcl.Graphics.clScrollBar;
  clBackground = Vcl.Graphics.clBackground;
  clActiveCaption = Vcl.Graphics.clActiveCaption;
  clInactiveCaption = Vcl.Graphics.clInactiveCaption;
  clMenu = Vcl.Graphics.clMenu;
  clWindow = Vcl.Graphics.clWindow;
  clWindowFrame = Vcl.Graphics.clWindowFrame;
  clMenuText = Vcl.Graphics.clMenuText;
  clWindowText = Vcl.Graphics.clWindowText;
  clCaptionText = Vcl.Graphics.clCaptionText;
  clActiveBorder = Vcl.Graphics.clActiveBorder;
  clInactiveBorder = Vcl.Graphics.clInactiveBorder;
  clAppWorkSpace = Vcl.Graphics.clAppWorkSpace;
  clHighlight = Vcl.Graphics.clHighlight;
  clHighlightText = Vcl.Graphics.clHighlightText;
  clBtnFace = Vcl.Graphics.clBtnFace;
  clBtnShadow = Vcl.Graphics.clBtnShadow;
  clGrayText = Vcl.Graphics.clGrayText;
  clBtnText = Vcl.Graphics.clBtnText;
  clInactiveCaptionText = Vcl.Graphics.clInactiveCaptionText;
  clBtnHighlight = Vcl.Graphics.clBtnHighlight;
  cl3DDkShadow = Vcl.Graphics.cl3DDkShadow;
  cl3DLight = Vcl.Graphics.cl3DLight;
  clInfoText = Vcl.Graphics.clInfoText;
  clInfoBk = Vcl.Graphics.clInfoBk;
  clHotLight = Vcl.Graphics.clHotLight;
  clGradientActiveCaption = Vcl.Graphics.clGradientActiveCaption;
  clGradientInactiveCaption = Vcl.Graphics.clGradientInactiveCaption;
  clMenuHighlight = Vcl.Graphics.clMenuHighlight;
  clMenuBar = Vcl.Graphics.clMenuBar;

  clBlack = Vcl.Graphics.clBlack;
  clMaroon = Vcl.Graphics.clMaroon;
  clGreen = Vcl.Graphics.clGreen;
  clOlive = Vcl.Graphics.clOlive;
  clNavy = Vcl.Graphics.clNavy;
  clPurple = Vcl.Graphics.clPurple;
  clTeal = Vcl.Graphics.clTeal;
  clGray = Vcl.Graphics.clGray;
  clSilver = Vcl.Graphics.clSilver;
  clRed = Vcl.Graphics.clRed;
  clLime = Vcl.Graphics.clLime;
  clYellow = Vcl.Graphics.clYellow;
  clBlue = Vcl.Graphics.clBlue;
  clFuchsia = Vcl.Graphics.clFuchsia;
  clAqua = Vcl.Graphics.clAqua;
  clLtGray = Vcl.Graphics.clLtGray;
  clDkGray = Vcl.Graphics.clDkGray;
  clWhite = Vcl.Graphics.clWhite;
  StandardColorsCount = 16;

  clMoneyGreen = Vcl.Graphics.clMoneyGreen;
  clSkyBlue = Vcl.Graphics.clSkyBlue;
  clCream = Vcl.Graphics.clCream;
  clMedGray = Vcl.Graphics.clMedGray;
  ExtendedColorsCount = 4;

  clNone = Vcl.Graphics.clNone;
  clDefault = Vcl.Graphics.clDefault;

  clWebSnow = Vcl.Graphics.clWebSnow;
  clWebFloralWhite = Vcl.Graphics.clWebFloralWhite;
  clWebLavenderBlush = Vcl.Graphics.clWebLavenderBlush;
  clWebOldLace = Vcl.Graphics.clWebOldLace;
  clWebIvory = Vcl.Graphics.clWebIvory;
  clWebCornSilk = Vcl.Graphics.clWebCornSilk;
  clWebBeige = Vcl.Graphics.clWebBeige;
  clWebAntiqueWhite = Vcl.Graphics.clWebAntiqueWhite;
  clWebWheat = Vcl.Graphics.clWebWheat;
  clWebAliceBlue = Vcl.Graphics.clWebAliceBlue;
  clWebGhostWhite = Vcl.Graphics.clWebGhostWhite;
  clWebLavender = Vcl.Graphics.clWebLavender;
  clWebSeashell = Vcl.Graphics.clWebSeashell;
  clWebLightYellow = Vcl.Graphics.clWebLightYellow;
  clWebPapayaWhip = Vcl.Graphics.clWebPapayaWhip;
  clWebNavajoWhite = Vcl.Graphics.clWebNavajoWhite;
  clWebMoccasin = Vcl.Graphics.clWebMoccasin;
  clWebBurlywood = Vcl.Graphics.clWebBurlywood;
  clWebAzure = Vcl.Graphics.clWebAzure;
  clWebMintcream = Vcl.Graphics.clWebMintcream;
  clWebHoneydew = Vcl.Graphics.clWebHoneydew;
  clWebLinen = Vcl.Graphics.clWebLinen;
  clWebLemonChiffon = Vcl.Graphics.clWebLemonChiffon;
  clWebBlanchedAlmond = Vcl.Graphics.clWebBlanchedAlmond;
  clWebBisque = Vcl.Graphics.clWebBisque;
  clWebPeachPuff = Vcl.Graphics.clWebPeachPuff;
  clWebTan = Vcl.Graphics.clWebTan;
  // yellows/reds yellow -> rosybrown
  clWebYellow = Vcl.Graphics.clWebYellow;
  clWebDarkOrange = Vcl.Graphics.clWebDarkOrange;
  clWebRed = Vcl.Graphics.clWebRed;
  clWebDarkRed = Vcl.Graphics.clWebDarkRed;
  clWebMaroon = Vcl.Graphics.clWebMaroon;
  clWebIndianRed = Vcl.Graphics.clWebIndianRed;
  clWebSalmon = Vcl.Graphics.clWebSalmon;
  clWebCoral = Vcl.Graphics.clWebCoral;
  clWebGold = Vcl.Graphics.clWebGold;
  clWebTomato = Vcl.Graphics.clWebTomato;
  clWebCrimson = Vcl.Graphics.clWebCrimson;
  clWebBrown = Vcl.Graphics.clWebBrown;
  clWebChocolate = Vcl.Graphics.clWebChocolate;
  clWebSandyBrown = Vcl.Graphics.clWebSandyBrown;
  clWebLightSalmon = Vcl.Graphics.clWebLightSalmon;
  clWebLightCoral = Vcl.Graphics.clWebLightCoral;
  clWebOrange = Vcl.Graphics.clWebOrange;
  clWebOrangeRed = Vcl.Graphics.clWebOrangeRed;
  clWebFirebrick = Vcl.Graphics.clWebFirebrick;
  clWebSaddleBrown = Vcl.Graphics.clWebSaddleBrown;
  clWebSienna = Vcl.Graphics.clWebSienna;
  clWebPeru = Vcl.Graphics.clWebPeru;
  clWebDarkSalmon = Vcl.Graphics.clWebDarkSalmon;
  clWebRosyBrown = Vcl.Graphics.clWebRosyBrown;
  // greens palegoldenrod -> darkseagreen
  clWebPaleGoldenrod = Vcl.Graphics.clWebPaleGoldenrod;
  clWebLightGoldenrodYellow = Vcl.Graphics.clWebLightGoldenrodYellow;
  clWebOlive = Vcl.Graphics.clWebOlive;
  clWebForestGreen = Vcl.Graphics.clWebForestGreen;
  clWebGreenYellow = Vcl.Graphics.clWebGreenYellow;
  clWebChartreuse = Vcl.Graphics.clWebChartreuse;
  clWebLightGreen = Vcl.Graphics.clWebLightGreen;
  clWebAquamarine = Vcl.Graphics.clWebAquamarine;
  clWebSeaGreen = Vcl.Graphics.clWebSeaGreen;
  clWebGoldenRod = Vcl.Graphics.clWebGoldenRod;
  clWebKhaki = Vcl.Graphics.clWebKhaki;
  clWebOliveDrab = Vcl.Graphics.clWebOliveDrab;
  clWebGreen = Vcl.Graphics.clWebGreen;
  clWebYellowGreen = Vcl.Graphics.clWebYellowGreen;
  clWebLawnGreen = Vcl.Graphics.clWebLawnGreen;
  clWebPaleGreen = Vcl.Graphics.clWebPaleGreen;
  clWebMediumAquamarine = Vcl.Graphics.clWebMediumAquamarine;
  clWebMediumSeaGreen = Vcl.Graphics.clWebMediumSeaGreen;
  clWebDarkGoldenRod = Vcl.Graphics.clWebDarkGoldenRod;
  clWebDarkKhaki = Vcl.Graphics.clWebDarkKhaki;
  clWebDarkOliveGreen = Vcl.Graphics.clWebDarkOliveGreen;
  clWebDarkgreen = Vcl.Graphics.clWebDarkgreen;
  clWebLimeGreen = Vcl.Graphics.clWebLimeGreen;
  clWebLime = Vcl.Graphics.clWebLime;
  clWebSpringGreen = Vcl.Graphics.clWebSpringGreen;
  clWebMediumSpringGreen = Vcl.Graphics.clWebMediumSpringGreen;
  clWebDarkSeaGreen = Vcl.Graphics.clWebDarkSeaGreen;
  // greens/blues lightseagreen -> navy
  clWebLightSeaGreen = Vcl.Graphics.clWebLightSeaGreen;
  clWebPaleTurquoise = Vcl.Graphics.clWebPaleTurquoise;
  clWebLightCyan = Vcl.Graphics.clWebLightCyan;
  clWebLightBlue = Vcl.Graphics.clWebLightBlue;
  clWebLightSkyBlue = Vcl.Graphics.clWebLightSkyBlue;
  clWebCornFlowerBlue = Vcl.Graphics.clWebCornFlowerBlue;
  clWebDarkBlue = Vcl.Graphics.clWebDarkBlue;
  clWebIndigo = Vcl.Graphics.clWebIndigo;
  clWebMediumTurquoise = Vcl.Graphics.clWebMediumTurquoise;
  clWebTurquoise = Vcl.Graphics.clWebTurquoise;
  clWebCyan = Vcl.Graphics.clWebCyan;
  clWebAqua = Vcl.Graphics.clWebAqua;
  clWebPowderBlue = Vcl.Graphics.clWebPowderBlue;
  clWebSkyBlue = Vcl.Graphics.clWebSkyBlue;
  clWebRoyalBlue = Vcl.Graphics.clWebRoyalBlue;
  clWebMediumBlue = Vcl.Graphics.clWebMediumBlue;
  clWebMidnightBlue = Vcl.Graphics.clWebMidnightBlue;
  clWebDarkTurquoise = Vcl.Graphics.clWebDarkTurquoise;
  clWebCadetBlue = Vcl.Graphics.clWebCadetBlue;
  clWebDarkCyan = Vcl.Graphics.clWebDarkCyan;
  clWebTeal = Vcl.Graphics.clWebTeal;
  clWebDeepskyBlue = Vcl.Graphics.clWebDeepskyBlue;
  clWebDodgerBlue = Vcl.Graphics.clWebDodgerBlue;
  clWebBlue = Vcl.Graphics.clWebBlue;
  clWebNavy = Vcl.Graphics.clWebNavy;
  // violets/pinks darkviolet -> pink
  clWebDarkViolet = Vcl.Graphics.clWebDarkViolet;
  clWebDarkOrchid = Vcl.Graphics.clWebDarkOrchid;
  clWebMagenta = Vcl.Graphics.clWebMagenta;
  clWebFuchsia = Vcl.Graphics.clWebFuchsia;
  clWebDarkMagenta = Vcl.Graphics.clWebDarkMagenta;
  clWebMediumVioletRed = Vcl.Graphics.clWebMediumVioletRed;
  clWebPaleVioletRed = Vcl.Graphics.clWebPaleVioletRed;
  clWebBlueViolet = Vcl.Graphics.clWebBlueViolet;
  clWebMediumOrchid = Vcl.Graphics.clWebMediumOrchid;
  clWebMediumPurple = Vcl.Graphics.clWebMediumPurple;
  clWebPurple = Vcl.Graphics.clWebPurple;
  clWebDeepPink = Vcl.Graphics.clWebDeepPink;
  clWebLightPink = Vcl.Graphics.clWebLightPink;
  clWebViolet = Vcl.Graphics.clWebViolet;
  clWebOrchid = Vcl.Graphics.clWebOrchid;
  clWebPlum = Vcl.Graphics.clWebPlum;
  clWebThistle = Vcl.Graphics.clWebThistle;
  clWebHotPink = Vcl.Graphics.clWebHotPink;
  clWebPink = Vcl.Graphics.clWebPink;
  // blue/gray/black lightsteelblue -> black
  clWebLightSteelBlue = Vcl.Graphics.clWebLightSteelBlue;
  clWebMediumSlateBlue = Vcl.Graphics.clWebMediumSlateBlue;
  clWebLightSlateGray = Vcl.Graphics.clWebLightSlateGray;
  clWebWhite = Vcl.Graphics.clWebWhite;
  clWebLightgrey = Vcl.Graphics.clWebLightgrey;
  clWebGray = Vcl.Graphics.clWebGray;
  clWebSteelBlue = Vcl.Graphics.clWebSteelBlue;
  clWebSlateBlue = Vcl.Graphics.clWebSlateBlue;
  clWebSlateGray = Vcl.Graphics.clWebSlateGray;
  clWebWhiteSmoke = Vcl.Graphics.clWebWhiteSmoke;
  clWebSilver = Vcl.Graphics.clWebSilver;
  clWebDimGray = Vcl.Graphics.clWebDimGray;
  clWebMistyRose = Vcl.Graphics.clWebMistyRose;
  clWebDarkSlateBlue = Vcl.Graphics.clWebDarkSlateBlue;
  clWebDarkSlategray = Vcl.Graphics.clWebDarkSlategray;
  clWebGainsboro = Vcl.Graphics.clWebGainsboro;
  clWebDarkGray = Vcl.Graphics.clWebDarkGray;
  clWebBlack = Vcl.Graphics.clWebBlack;
{$ENDIF}

type
  TImageType = (itBase64, itBMP, itPNG, itJPEG, itGIF);


  TGraphicHelper = class helper for TGraphic
    function GetBase64Image: string;
    function GetAsImage(AType: TImageType = itBase64): string;
    procedure LoadFromURL(AURL: string); overload;
    procedure LoadFromURL(AURL: string; AHInstance: Integer); overload;
  end;

  TCanvasHelper = class helper for TCanvas
    function GetBase64Image: string;
    procedure DownloadImage( AFileName: string; AType: TImageType = itPNG);
    function GetAsImage(AType: TImageType): string;
  end;

  {$IFNDEF LCLTMSWEB}
  TThumbnailCreatedProc = reference to procedure(ADataURL: string);
  {$ENDIF}
  {$IFDEF LCLTMSWEB}
  TThumbnailCreatedProc = procedure(ADataURL: string) of object;
  {$ENDIF}


function ColorToRGB(Color: TColor): Longint;
function ColorToHex(c: TColor): string;
function ColorToHTML(c: TColor): string;
function HTMLChar(h: string): integer;
function HexToColor(h: string): TColor;
function FontSizeToPx(sz: Double): Double;
function GetRValue(rgb: NativeInt): Byte;
function GetGValue(rgb: NativeInt): Byte;
function GetBValue(rgb: NativeInt): Byte;
function RGB(r, g, b: Byte): TColor;
function CSSFont(Font: TFont): string;

procedure CreateThumbnail(ADataURL: string; AWidth, AHeight: integer; UseAspectRatio: boolean; ThumbnailReady: TThumbnailCreatedProc);


implementation

uses
  SysUtils;

procedure CreateThumbnail(ADataURL: string; AWidth, AHeight: integer; UseAspectRatio: boolean; ThumbnailReady: TThumbnailCreatedProc);
begin
end;

procedure SetJSHTMLElementColor(AElement: TJSHTMLElement; AColor: TColor);
begin
end;

function ColorToRGB(Color: TColor): Longint;
begin
  Result := 0;
end;

function ColorToHex(c: TColor): string;
begin
  Result := '';
end;

function ColorToHTML(c: TColor): string;
begin
  Result := '';
end;

function HexToColor(h: string): TColor;
begin
  Result := clNone;
end;

function FontSizeToPx(sz: Double): Double;
begin
  Result := 0;
end;

function GetRValue(rgb: NativeInt): Byte;
begin
  Result := 0;
end;

function GetGValue(rgb: NativeInt): Byte;
begin
  Result := 0;
end;

function GetBValue(rgb: NativeInt): Byte;
begin
  Result := 0;
end;

function RGB(r, g, b: Byte): TColor;
begin
  Result := clNone;
end;

function HTMLChar(h: string): integer;
begin
  // fmt &#xABCD;
  Delete(h,1,3);
  Delete(h,Length(h), 1);
  try
    Result := StrToInt('0x' + h);
  except
    Result := 0;
  end;
end;

function CSSFont(Font: TFont): string;
begin
end;

{ TGraphicHelper }

function TGraphicHelper.GetAsImage(AType: TImageType): string;
begin
  Result := '';
end;

function TGraphicHelper.GetBase64Image: string;
begin
  Result := '';
end;

procedure TGraphicHelper.LoadFromURL(AURL: string);
begin
  //
end;

procedure TGraphicHelper.LoadFromURL(AURL: string; AHInstance: Integer);
begin
  //
end;

{ TCanvasHelper }

procedure TCanvasHelper.DownloadImage(AFileName: string; AType: TImageType);
begin
  //
end;

function TCanvasHelper.GetBase64Image: string;
begin
  Result := '';
end;

function TCanvasHelper.GetAsImage(AType: TImageType): string;
begin
  Result := '';
end;

end.
