{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019 - 2020                               }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}
unit WEBLib.Sentry;

interface

uses
  Classes, WEBLib.Controls, Web, jsdelphisystem, js;

type
  {$IFNDEF LCLTMSWEB}
  [ComponentPlatforms(TMSWebPlatform)]
  [JSLibReference('https://browser.sentry-cdn.com/5.22.3/bundle.min.js')]
  {$ENDIF}
  TWebSentry = class(TComponent)
  strict private
    fEnabled: Boolean;
    fDSN, fRelease: String;
  public
    constructor Create(AOwner: TComponent); override;
    procedure Init;
    procedure CaptureMessage(aMsg: String);
    procedure CaptureException(anObj: TJSObject; remark: String='');
    procedure SetUser(aName: String);
    procedure SetTag(aKey: String; aValue: String);
    procedure AddBreadcrumb(aCategory: String; aMessage: String);
  published
    property Enabled: Boolean read fEnabled write fEnabled;
    property DSN: String read fDSN write fDSN;
    property Release: String read fRelease write fRelease;
  end;

implementation

constructor TWebSentry.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  DSN := '';
  fRelease := '1.0';
  fEnabled := True;
end;

procedure TWebSentry.Init;
begin
end;

procedure TWebSentry.CaptureMessage(aMsg: String);
begin
end;

procedure TWebSentry.CaptureException(anObj: TJSObject; remark: String='');
begin
end;

procedure TWebSentry.SetUser(aName: String);
begin
end;

procedure TWebSentry.SetTag(aKey: String; aValue: String);
begin
end;

procedure TWebSentry.AddBreadcrumb(aCategory: String; aMessage: String);
begin
end;

end.
