unit libpushsubscription;

{$IFDEF LCLTMSWEB}
{$MODE ObjFPC}
{$H+}
{$modeswitch externalclass}
{$ENDIF}

interface

uses
  SysUtils, JS, web, libserviceworkers;

type
  // Forward class definitions
  TJSPushSubscriptionOptions = class;
  TJSPrincipal = class;
  TJSPushSubscription = class;
  TJSPushSubscriptionKeys = class;
  TJSPushSubscriptionJSON = class;
  TJSPushSubscriptionInit = class;
  PushEncryptionKeyName = string;
  
  { --------------------------------------------------------------------
    TJSPushSubscriptionKeys
    --------------------------------------------------------------------}
  
  TJSPushSubscriptionKeys = class(TJSObject)
    p256dh : string;
    auth : string;
  end;

  { --------------------------------------------------------------------
    TJSPushSubscriptionJSON
    --------------------------------------------------------------------}

  TJSPushSubscriptionJSON = class(TJSObject)
    endpoint : string;
    keys_ : TJSPushSubscriptionKeys;
  end;
  
  { --------------------------------------------------------------------
    TJSPushSubscriptionInit
    --------------------------------------------------------------------}
  
  TJSPushSubscriptionInit = class(TJSObject)
    endpoint : string;
    scope : string;
    p256dhKey : TJSArrayBuffer;
    authSecret : TJSArrayBuffer;
    appServerKey : TJSBufferSource;
  end;
  
  { --------------------------------------------------------------------
    TJSPushSubscriptionOptions
    --------------------------------------------------------------------}
  
  TJSPushSubscriptionOptions = class
  private
    FapplicationServerKey : TJSArrayBuffer;
  public
    property applicationServerKey : TJSArrayBuffer read FapplicationServerKey;
  end;
  
  { --------------------------------------------------------------------
    TJSPrincipal
    --------------------------------------------------------------------}

  TJSPrincipal = class
  private
  public
  end;
  
  { --------------------------------------------------------------------
    TJSPushSubscription
    --------------------------------------------------------------------}
  
  TJSPushSubscription = class
  private
    Fendpoint : string;
    Foptions : TJSPushSubscriptionOptions;
  public
    function getKey(name : PushEncryptionKeyName): TJSArrayBuffer;
    function unsubscribe: TJSPromise;
    function toJSON: TJSPushSubscriptionJSON;
    property endpoint : string read Fendpoint;
    property options : TJSPushSubscriptionOptions read Foptions;
  end;

implementation


{ TJSPushSubscription }

function TJSPushSubscription.getKey(
  name: PushEncryptionKeyName): TJSArrayBuffer;
begin
  Result := nil;
end;

function TJSPushSubscription.toJSON: TJSPushSubscriptionJSON;
begin
  Result := nil;
end;

function TJSPushSubscription.unsubscribe: TJSPromise;
begin
  Result := nil;
end;

end.
