{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            copyright (c) 2019                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.DreamFactoryCDS;

//{$define cdsdebug}

interface

uses
   Classes, JS, Web, SysUtils, WEBLib.CDS, JSONDataSet,
   DB, WebLib.REST, strutils;

type
  TDreamFactoryClientDataset = class;
  TDreamFactoryClientDataProxy = class;

  TDreamFactory = class(TRESTClient)
  protected
    procedure HttpsCommand(Command, URL, Data, ContentType: string; headers: TCoreCloudHeaders); override;
    procedure DoConnect(Username, Password: String; IsSignup: Boolean);
    procedure HandleLogin(Sender: TObject; AResponse: String;
                               var Handled: Boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
  end;

  TDreamFactoryEntityUpdate = class(TCollectionItem)
  protected
    procedure HandleInsert(Sender: TObject; AResponse: String; var Handled: Boolean);
    procedure HandleUpdateDelete(Sender: TObject; AResponse: String; var Handled: Boolean);
  public
    constructor Create(Collection: TCollection);  override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function Update: Boolean;
    function Insert: Boolean;
    function Delete: Boolean;
    property CustomData: JSValue read FCustomData write FCustomData;
    property Data: TJSObject read FData write FData;
  end;

  TDreamFactoryEntityUpdates = class(TOwnedCollection)
  protected
    property DataProxy: TDreamFactoryClientDataProxy read FDataProxy;
  public
    constructor Create(AOwner: TPersistent); reintroduce;
    function Add: TDreamFactoryEntityUpdate; reintroduce;
    function Insert(Index: Integer): TDreamFactoryEntityUpdate; reintroduce;
    property Items[Index: Integer]: TDreamFactoryEntityUpdate read GetItems write SetItems; default;
  end;

  TDreamFactoryClientDataProxy = Class(TDataProxy)
 protected
    function GetDataRequest(aOptions: TLoadOptions; aAfterRequest: TDataRequestEvent; aAfterLoad: TDatasetLoadEvent) : TDataRequest; override;
    function DoGetData(aRequest : TDataRequest) : Boolean; override;
    procedure DoOnError(errCode: Integer; errMsg: String);
    procedure DoOnEntityError(anEntityUpdate: TDreamFactoryEntityUpdate; errCode: Integer; errMsg: String);
    procedure DoOnEntityUpdateDelete(anEntityUpdate: TDreamFactoryEntityUpdate);
    procedure DoOnEntityInsert(anEntityUpdate: TDreamFactoryEntityUpdate);
    procedure DoOnConnect(Sender: TObject);
    procedure GetEntities;
    function GetRealResponse(AResponse: String; out anOutput: JSValue): Boolean;
    function GetRealResponseFirstObject(AResponse: String; out anOutput: JSValue): Boolean;
    procedure HandleGetEntities(Sender: TObject; AResponse: String; var Handled: Boolean);
    procedure ProcessUpdate(desc: TRecordUpdateDescriptor);
    procedure Close;
    // Dummy but necessary only as it is an Abstract method
    function ProcessUpdateBatch(aBatch: TRecordUpdateBatch): Boolean; override;
    function GetKeyFieldName: String;
    function GetTableName: String;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property TableName: String read GetTableName;
    property Db: TDreamFactory read FDb;
    property KeyFieldName: String read GetKeyFieldName;
  end;

  TDreamFactoryErrorEvent = procedure(Sender: TObject; errCode: Integer; errMsg: String) of object;
  TDreamFactorySignupUserExistsEvent = procedure(Sender: TObject; UserName: String) of object;

  TDreamFactoryClientDataset = Class(TClientDataSet)
  protected
    procedure InternalClose; override;
    Function AddToChangeList(aChange : TUpdateStatus) : TRecordUpdateDescriptor ; override;
    procedure SetActive(Value: Boolean); override;
    procedure AfterLoadDFMValues; override;
    procedure DoAfterOpen; override;
    procedure DoOnError(errCode: Integer; errMsg: String);
    procedure UpdateStarts;
    procedure UpdateEnds;
    function GetQueryParameter(aCommand: THTTPCommand): String; virtual;
    procedure FixKeyFieldCase;
    function IsKeyFieldValid: Boolean;
    property DataLoaded: Boolean read FDataLoaded write FDataLoaded;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Force: Boolean=False); reintroduce;
    procedure AddSortFieldDef(aField: String; isAscending: Boolean);
    procedure ClearSortFieldDefs;
    procedure Login(aUserName, aPassword: String; IsSignUp: Boolean=False);

  published
    property DreamFactoryURL: String read FDreamFactoryURL write FDreamFactoryURL;
    property TableName: String read FTableName write FTableName;
    property KeyFieldName: String read FKeyFieldName write FKeyFieldName;
    property ApiKey: String read FApiKey write FApiKey;
    property DbServiceName: String read FDbServiceName write FDbServiceName;
    property OnError: TDreamFactoryErrorEvent read FOnError write FOnError;
    property OnUserExists: TDreamFactorySignupUserExistsEvent read FOnUserExists write FOnUserExists;
  end;

  TWebDreamFactoryClientDataset = class(TDreamFactoryClientDataset);

implementation
end.
