{$Error This is a closed source unit. You cannot compile it, it was already compiled.}
{$Error Probably the IDE has cleaned up and you have to unpack the zip again.}
{********************************************************************}
{                                                                    }
{ written by TMS Software                                            }
{            Copyright (c) 2020                                      }
{            Email : info@tmssoftware.com                            }
{            Web : http://www.tmssoftware.com                        }
{                                                                    }
{ The source code is given as is. The author is not responsible      }
{ for any possible damage done due to the use of this code.          }
{ The complete source code remains property of the author and may    }
{ not be distributed, published, given or sold in any form as such.  }
{ No parts of the source code can be included in any other component }
{ or application without written authorization of the author.        }
{********************************************************************}

unit WEBLib.SignatureCapture;

interface

uses
  Classes, WEBLib.Controls, Types, Contnrs, WEBLib.Graphics, web;

type
  TSignatureCaptureLineTextPosition = (ltpBottomLeft, ltpBottomCenter, ltpBottomRight, ltpTopLeft, ltpTopCenter, ltpTopRight, ltpXY);

  TSignatureCaptureSignTextPosition = class(TPersistent)
  protected
    procedure Changed; virtual;
  public
    constructor Create;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  published
    property Line: TPen read FLine write SetLine;
    property LineVisible: Boolean read FLineVisible write SetLineVisible;
    property Position: TSignatureCaptureLineTextPosition read FPosition write SetPosition;
    property X: Integer read FX write SetX;
    property Y: Integer read FY write SetY;
  end;

  TSignatureCapturePoint = class(TObject)
  public
    X, Y, PenWidth: Integer;
    DrawLine: Boolean;
    PenColor: TColor;
    PenStyle: TPenStyle;
  end;

  TSignatureCapturePoints = class(TObjectList)
  public
    property Items[Index: Integer]: TSignatureCapturePoint read GetItem write SetItem; default;
  end;

  TSignatureCaptureClearButtonPosition = (cbpTopLeft, cbpTopRight, cbpBottomLeft, cbpBottomRight, cbpXY);

  TSignatureCaptureClearButton = class(TPersistent)
  protected
    procedure Changed; virtual;
    procedure ImageChange(Sender: TObject);
  public
    constructor Create;
    destructor Destroy; override;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  published
    property Image: TURLPicture read FImage write SetImage;
    property Position: TSignatureCaptureClearButtonPosition read FPosition write SetPosition;
    property X: Integer read FX write SetX;
    property Y: Integer read FY write SetY;
  end;

  TSignatureCapture = class(TCustomControl)
  protected
    procedure CreateInitialize; override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer); override;
    procedure Paint; override;
    procedure PaintSignature(ACanvas: TCanvas); virtual;
    procedure PaintClearButton; virtual;
    procedure PaintLine; virtual;
    procedure PaintText; virtual;
    procedure ClearBtnChanged(Sender: TObject);
    procedure ButtonChanged(Sender: TObject);
    procedure TextPositionChanged(Sender: TObject);
    function GetLineY: Integer;
    function InClearRect(AX, AY: Integer): Boolean;
  public
    destructor Destroy; override;
    function GetAsBase64Image: string;
    property Empty: Boolean read GetEmpty write SetEmpty;
  published
    property Align;
    property Anchors;
    property ChildOrder;
    property ShowHint;
    property Visible;
    property TabOrder;
    property TabStop;
    property ClearButton: TSignatureCaptureClearButton read FClearButton write SetClearButton;
    property TextPosition: TSignatureCaptureSignTextPosition read FTextPosition write SetTextPosition;
    property Text: string read FText write SetText;
    property Pen: TPen read FPen write SetPen;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TWebSignatureCapture = class(TSignatureCapture);

implementation
end.
